package com.sd.cainiao.service.impl;

import com.ruoyi.common.exception.ServiceException;
import com.sd.cainiao.entity.bo.BasicKeyBo;
import com.sd.cainiao.entity.dto.TakeNumParamDto;
import com.sd.cainiao.service.IsticeService;
import com.taobao.pac.sdk.cp.PacClient;
import com.taobao.pac.sdk.cp.SendSysParams;
import com.taobao.pac.sdk.cp.dataobject.request.TMS_WAYBILL_GET.*;
import com.taobao.pac.sdk.cp.dataobject.response.TMS_WAYBILL_GET.TmsWaybillGetResponse;
import com.taobao.pac.sdk.cp.dataobject.response.TMS_WAYBILL_GET.WaybillCloudPrintResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@Service
public class IsticeServiceImpl implements IsticeService {

    @Autowired
    private BasicKeyBo basicKeyBo;

    @Override
    public List<Map<String, Object>> takeNumBatch(List<TakeNumParamDto> dto) {

        // List<Map<String, Object>> resultList = new ArrayList<>();
        //
        // for (TakeNumParamDto takeNumParam : dto) {
        //     if (StringUtils.isEmpty(takeNumParam.getId()) || StringUtils.isEmpty(takeNumParam.getAddressId())) {
        //         throw new ServiceException("参数异常");
        //     }
        //
        //     // 根据快递ID去除所有包裹得运单号
        //     UpdateWrapper<ExpressPacking> updateWrapper = new UpdateWrapper<>();
        //     updateWrapper.set("waybill_no", null);
        //     updateWrapper.eq("express_id", takeNumParam.getId());
        //     iExpressPackingService.update(updateWrapper);
        //
        //     Map<String, Object> result = new HashMap<>();
        //
        //     // 查询发货模板
        //     Address address = addressService.getById(takeNumParam.getAddressId());
        //     takeNumParam.setCpCode(address.getExpressageCode());
        //     takeNumParam.setPhone(address.getPhone());
        //     takeNumParam.setMobile(address.getPhone());
        //     takeNumParam.setProvince(address.getProvince());
        //     takeNumParam.setName(address.getName());
        //     takeNumParam.setCity(address.getCity());
        //     takeNumParam.setDetail(address.getAddress());
        //     takeNumParam.setDistrict(address.getDistrict());
        //     takeNumParam.setEmsTemplateUrl(address.getTemplateUrl());
        //     // 查询装箱数
        //     List<ExpressPacking> expressPackingList = iExpressPackingService.list(Wrappers.<ExpressPacking>query().lambda().
        //             eq(ExpressPacking::getExpressId, takeNumParam.getId()));
        //     // 取出所有装箱ID
        //     List<String> expressPackingIds = expressPackingList.stream().map(ExpressPacking::getId).collect(Collectors.toList());
        //     // 查询装箱商品信息
        //     List<ExpressPackingProduct> packingProductList = iExpressPackingProductService.getContractProductData(expressPackingIds);
        //     Map<String, List<ExpressPackingProduct>> map = packingProductList.stream().collect(Collectors.groupingBy(ExpressPackingProduct::getExpressPackingId));
        //     // 处理装箱数量.重新计算箱子数
        //     List<ExpressPacking> newExpressPackingList = new ArrayList<>();
        //     for (ExpressPacking packing : expressPackingList) {
        //         for (int i = 0; i < packing.getTotal(); i++) {
        //             newExpressPackingList.add(packing);
        //         }
        //     }
        //     // 批量取号
        //     List<JSONObject> list = new ArrayList<>();
        //     for (ExpressPacking e : newExpressPackingList) {
        //
        //         takeNumParam.setOrderNum(IdUtils.dateUUID());
        //         takeNumParam.setObjectId(IdUtils.dateUUID());
        //         // 赋值产品信息
        //         if (MapUtils.isNotEmpty(map)) {
        //             List<ExpressPackingProduct> productList = map.get(e.getId());
        //             StringBuilder builder = new StringBuilder();
        //             for (ExpressPackingProduct p : productList) {
        //                 List<ItemParam> itemParamList = new ArrayList<>();
        //                 builder.append(p.getProductColorName()).append("*").append(p.getQuantity()).append("\n");
        //                 ItemParam itemParam = new ItemParam();
        //                 itemParam.setItemName(p.getContractProductName() + p.getProductColorName());
        //                 itemParam.setItemCount(p.getContractProductQuantity());
        //                 itemParamList.add(itemParam);
        //                 takeNumParam.setItems(itemParamList);
        //             }
        //
        //             TmsWaybillGetResponse response = this.takeNum(takeNumParam);
        //             WaybillCloudPrintResponse printResponse = response.getWaybillCloudPrintResponseList().get(0);
        //             String re = printResponse.getPrintData();
        //             JSONObject jsonObject = JSONObject.parseObject(re);
        //
        //             // 赋值订单号
        //             List<String> stringList = new ArrayList<>();
        //             ExpressPacking dataPack = iExpressPackingService.getById(e.getId());
        //             if (StringUtils.isNotEmpty(dataPack.getWaybillNo())) {
        //                 stringList.add(dataPack.getWaybillNo());
        //             }
        //             stringList.add(printResponse.getWaybillCode());
        //             ExpressPacking packing = new ExpressPacking();
        //             packing.setWaybillNo(StringUtils.join(stringList, ","));
        //             packing.setId(e.getId());
        //             iExpressPackingService.updateById(packing);
        //             // 拼接模板
        //             jsonObject.put("detail", builder.toString());
        //             jsonObject.put("customTemplateUrl", address.getCustomTemplateUrl());
        //             list.add(jsonObject);
        //         }
        //     }
        //     result.put("packingList", list);
        //     resultList.add(result);
        // }
        // return resultList;
        return null;
    }

    public List<WaybillCloudPrintResponse> takeNum(TakeNumParamDto dto) {
        PacClient client = new PacClient(basicKeyBo.getAppKey(), basicKeyBo.getSecretKey(), basicKeyBo.getUrl());

        SendSysParams params = new SendSysParams();
        params.setFromCode(basicKeyBo.getToken());

        TmsWaybillGetRequest request = new TmsWaybillGetRequest();
        // 配送公司编码
        request.setCpCode(dto.getCpCode());
        // 发件人信息
        request.setSender(getSender(dto));
        // 交易订单信息
        request.setTradeOrderInfoDtos(getTradeOrderInfoDtoList(dto));

        TmsWaybillGetResponse response = client.send(request, params);

        if (response.isSuccess()) {
            return response.getWaybillCloudPrintResponseList();
        }

        throw new ServiceException(response.getErrorMsg());
    }

    /**
     * 获取交易订单信息
     */
    private List<TradeOrderInfoDto> getTradeOrderInfoDtoList(TakeNumParamDto dto) {
        List<TradeOrderInfoDto> tradeOrderInfoDtoList = new ArrayList<>();

        // 收件信息
        TradeOrderInfoDto tradeOrderInfoDto = new TradeOrderInfoDto();
        tradeOrderInfoDto.setObjectId(dto.getObjectId());
        tradeOrderInfoDto.setTemplateUrl(dto.getEmsTemplateUrl());
        tradeOrderInfoDto.setOrderInfo(getOrderInfoDto(dto));
        tradeOrderInfoDto.setPackageInfo(getPackageInfo(dto));
        tradeOrderInfoDto.setRecipient(getRecipient(dto));
        tradeOrderInfoDtoList.add(tradeOrderInfoDto);

        return tradeOrderInfoDtoList;
    }

    /**
     * 订单信息
     */
    private OrderInfoDto getOrderInfoDto(TakeNumParamDto dto) {
        OrderInfoDto orderInfoDto = new OrderInfoDto();
        orderInfoDto.setOrderChannelsType("OTHERS");
        orderInfoDto.setTradeOrderList(Collections.singletonList(dto.getOrderNum()));
        return orderInfoDto;
    }

    /**
     * 包装信息
     */
    private PackageInfoDto getPackageInfo(TakeNumParamDto dto) {
        // 商品信息
        List<Item> itemList = dto.getItems().stream().map(itemParamDto -> {
            Item item = new Item();
            item.setName(itemParamDto.getItemName());
            item.setCount(itemParamDto.getItemCount());
            return item;
        }).collect(Collectors.toList());

        PackageInfoDto packageInfoDto = new PackageInfoDto();
        packageInfoDto.setWeight(dto.getWeight());
        packageInfoDto.setVolume(dto.getVolume());
        packageInfoDto.setItems(itemList);
        return packageInfoDto;
    }

    /**
     * 获取发件人发件地址
     */
    private UserInfoDto getSender(TakeNumParamDto dto) {
        // 寄件地址，这里的地址需要是卖家订购电子面单服务时使用的订购地址，具体可以通过TMS_WAYBILL_SUBSCRIPTION_QUERY接口获取
        AddressDto sendAddress = new AddressDto();
        sendAddress.setProvince(dto.getProvince());
        sendAddress.setCity(dto.getCity());
        sendAddress.setDistrict(dto.getDistrict());
        sendAddress.setDetail(dto.getDetail());

        UserInfoDto sender = new UserInfoDto();
        sender.setName(dto.getName());
        sender.setPhone(dto.getPhone());
        sender.setMobile(dto.getMobile());
        sender.setAddress(sendAddress);
        return sender;
    }

    /**
     * 获取收件人收件地址
     */
    private UserInfoDto getRecipient(TakeNumParamDto dto) {
        AddressDto receiveAddress = new AddressDto();
        receiveAddress.setProvince(dto.getReceiveProvince());
        receiveAddress.setCity(dto.getReceiveCity());
        receiveAddress.setDistrict(dto.getReceiveDistrict());
        receiveAddress.setDetail(dto.getReceiveDetail());

        UserInfoDto receiver = new UserInfoDto();
        receiver.setName(dto.getReceiveName());
        receiver.setMobile(dto.getReceiveMobile());
        receiver.setAddress(receiveAddress);
        return receiver;
    }

}
